﻿//Code to demonstrate working of finalize() method.
package com.javacodegeeks.finalizedemo;

public class FinalizeDemo {

  //Main method of the function
  public static void main(String[ ] args) {
    //Creating an object of the class 'FinalizeDemo'
    FinalizeDemo fd = new FinalizeDemo();
    
    try {
      //Explicit call to finalize() method
      System.out.println("Before calling finalize() explicitly");
      fd.finalize();
    
      //Calling Garbage Collector method which implicitly calls finalize() method
      System.out.println("Before calling Garbage Collector");
      System.gc();
      System.out.println("Garbage collected");
    } catch(Throwable e) {
      System.out.println("An exception occured");
      e.printStackTrace();
    }
  }

  //Overriding finalize() method.
  @Override
  protected void finalize() throws Throwable {
    System.out.println("Inside finalize() method");
  }
}
